Index: codes/icosagcm/devel/src/dynamics/caldyn_gcm.F90
===================================================================
--- codes/icosagcm/devel/src/dynamics/caldyn_gcm.F90	(revision 728)
+++ codes/icosagcm/devel/src/dynamics/caldyn_gcm.F90	(revision 731)
@@ -2,4 +2,5 @@
   USE icosa
   USE transfert_mod
+  USE caldyn_vars_mod
   USE caldyn_kernels_hevi_mod
   USE caldyn_kernels_base_mod
@@ -141,5 +142,4 @@
 
   SUBROUTINE allocate_caldyn
-    CALL allocate_field(f_out_u,field_u,type_real,llm) 
     CALL allocate_field(f_qu,field_u,type_real,llm) 
     CALL allocate_field(f_qv,field_z,type_real,llm) 
Index: codes/icosagcm/devel/src/dynamics/caldyn_hevi.f90
===================================================================
--- codes/icosagcm/devel/src/dynamics/caldyn_hevi.f90	(revision 728)
+++ codes/icosagcm/devel/src/dynamics/caldyn_hevi.f90	(revision 731)
@@ -2,6 +2,7 @@
   USE icosa
   USE transfert_mod
+  USE caldyn_vars_mod
+  USE caldyn_kernels_hevi_mod
   USE caldyn_kernels_base_mod
-  USE caldyn_kernels_hevi_mod
   USE caldyn_gcm_mod
   IMPLICIT NONE
Index: codes/icosagcm/devel/src/dynamics/caldyn_kernels.f90
===================================================================
--- codes/icosagcm/devel/src/dynamics/caldyn_kernels.f90	(revision 728)
+++ codes/icosagcm/devel/src/dynamics/caldyn_kernels.f90	(revision 731)
@@ -2,10 +2,9 @@
   USE icosa
   USE transfert_mod
-  USE caldyn_kernels_base_mod
+  USE caldyn_vars_mod
   IMPLICIT NONE
   PRIVATE
 
-  PUBLIC :: compute_planetvel, compute_pvort, compute_geopot, &
-       compute_caldyn_horiz, compute_caldyn_vert
+  PUBLIC :: compute_planetvel, compute_pvort, compute_caldyn_horiz
 CONTAINS
 
Index: codes/icosagcm/devel/src/dynamics/caldyn_kernels_base.F90
===================================================================
--- codes/icosagcm/devel/src/dynamics/caldyn_kernels_base.F90	(revision 728)
+++ codes/icosagcm/devel/src/dynamics/caldyn_kernels_base.F90	(revision 731)
@@ -3,22 +3,10 @@
   USE transfert_mod
   USE disvert_mod
+  USE caldyn_vars_mod
   USE omp_para
   USE trace
   IMPLICIT NONE
   PRIVATE
-
-  INTEGER, PARAMETER,PUBLIC :: energy=1, enstrophy=2
-  TYPE(t_field),POINTER,PUBLIC :: f_out_u(:), f_qu(:), f_qv(:)
-  REAL(rstd),SAVE,POINTER :: out_u(:,:), p(:,:), qu(:,:)
-  !$OMP THREADPRIVATE(out_u, p, qu)
-
-  ! temporary shared variables for caldyn
-  TYPE(t_field),POINTER,PUBLIC :: f_pk(:),f_wwuu(:),f_planetvel(:), &
-                                  f_Fel(:), f_gradPhi2(:), f_wil(:), f_Wetadot(:)
-
-  INTEGER, PUBLIC :: caldyn_conserv
-  !$OMP THREADPRIVATE(caldyn_conserv) 
-
-  TYPE(t_message),PUBLIC :: req_ps, req_mass, req_theta_rhodz, req_u, req_qu, req_geopot, req_w
+  SAVE
 
   PUBLIC :: compute_geopot, compute_caldyn_vert, compute_caldyn_vert_nh
Index: codes/icosagcm/devel/src/dynamics/caldyn_kernels_hevi.F90
===================================================================
--- codes/icosagcm/devel/src/dynamics/caldyn_kernels_hevi.F90	(revision 728)
+++ codes/icosagcm/devel/src/dynamics/caldyn_kernels_hevi.F90	(revision 731)
@@ -5,5 +5,5 @@
   USE disvert_mod
   USE transfert_mod
-  USE caldyn_kernels_base_mod
+  USE caldyn_vars_mod
   IMPLICIT NONE
   PRIVATE
Index: codes/icosagcm/devel/src/dynamics/caldyn_vars.f90
===================================================================
--- codes/icosagcm/devel/src/dynamics/caldyn_vars.f90	(revision 731)
+++ codes/icosagcm/devel/src/dynamics/caldyn_vars.f90	(revision 731)
@@ -0,0 +1,19 @@
+MODULE caldyn_vars_mod
+  USE icosa
+  USE transfert_mod
+  IMPLICIT NONE
+  PUBLIC
+  SAVE
+
+  INTEGER, PARAMETER :: energy=1, enstrophy=2
+
+  ! temporary shared variables for caldyn
+  TYPE(t_field),POINTER :: f_qu(:), f_qv(:), f_pk(:),f_wwuu(:),f_planetvel(:), &
+                           f_Fel(:), f_gradPhi2(:), f_wil(:), f_Wetadot(:)
+
+  INTEGER :: caldyn_conserv
+  !$OMP THREADPRIVATE(caldyn_conserv) 
+
+  TYPE(t_message) :: req_ps, req_mass, req_theta_rhodz, req_u, req_qu, req_geopot, req_w
+
+END MODULE caldyn_vars_mod